 /***********************************************************************
 *                                                                      *
 * port.h                                                               *
 * This is port driver header file for SVT17702.                        *
 * History :  2008/03/26  Start.                                        *
 *                                                                      *
 ************************************************************************/
 
#ifndef _PORT_H
#define _PORT_H

extern void setPortInput(unsigned char inputBitP0, unsigned char inputBitP1, unsigned char inputBitP2, unsigned char inputBitP3);
extern void setPortOutput(unsigned char outputBitP0, unsigned char outputBitP1, unsigned char outputBitP2, unsigned char outputBitP3);
extern void setPortPullupOn(unsigned char onBitP0, unsigned char onBitP1, unsigned char onBitP2, unsigned char onBitP3);
extern void setPortPullupOff(unsigned char offBitP0, unsigned char offBitP1, unsigned char offBitP2, unsigned char offBitP3);
extern void setPortCmosSchimitt(unsigned char schimittBitP0, unsigned char schimittBitP1, unsigned char schimittBitP2, unsigned char schimittBitP3);
extern void setPortCmos(unsigned char cmosBitP0, unsigned char cmosBitP1, unsigned char cmosBitP2, unsigned char cmosBitP3);
extern void setP0Chat0to3(unsigned char time);
extern void setP0Chat4to7(unsigned char time);
extern void setP1Chat0to3(unsigned char time);
extern void setP1Chat4to7(unsigned char time);
extern unsigned char getPInput(unsigned char portNo);
extern void setPoutput(unsigned char portNo, unsigned char data);
extern void setPortOutDataH(unsigned char putBitP0, unsigned char putBitP1, unsigned char putBitP2, unsigned char putBitP3);
extern void setPortOutDataL(unsigned char putBitP0, unsigned char putBitP1, unsigned char putBitP2, unsigned char putBitP3);
extern void initP0Int(unsigned char intLevel);
extern void initP1Int(unsigned char intLevel);
extern void contorlP0IputOn(unsigned char setBit);
extern void contorlP1IputOn(unsigned char setBit);
extern void contorlP2IputOn(unsigned char setBit);
extern void contorlP3IputOn(unsigned char setBit);
extern void contorlP0IputOff(unsigned char setBit);
extern void contorlP1IputOff(unsigned char setBit);
extern void contorlP2IputOff(unsigned char setBit);
extern void contorlP3IputOff(unsigned char setBit);
extern void setP0IntEdgeUp(unsigned char upBit);
extern void setP1IntEdgeUp(unsigned char upBit);
extern void setP0IntEdgeDown(unsigned char downBit);
extern void setP1IntEdgeDown(unsigned char downBit);
extern void startP0Int(unsigned char startBit);
extern void startP1Int(unsigned char startBit);
extern void stopP0Int(unsigned char stopBit);
extern void stopP1Int(unsigned char stopBit);
extern void resetP0IF(unsigned char resetBit);
extern void resetP1IF(unsigned char resetBit);

extern char isP00Int(void);
extern char isP01Int(void);
extern char isP02Int(void);
extern char isP03Int(void);
extern char isP04Int(void);
extern char isP05Int(void);
extern char isP06Int(void);
extern char isP07Int(void);
extern char isP10Int(void);
extern char isP11Int(void);
extern char isP12Int(void);
extern char isP13Int(void);
extern char isP14Int(void);
extern char isP15Int(void);
extern char isP16Int(void);
extern char isP17Int(void);

#define	P_BIT_X0				0x01	// PX0
#define	P_BIT_X1				0x02	// PX1
#define	P_BIT_X2				0x04	// PX2
#define	P_BIT_X3				0x08	// PX3
#define	P_BIT_X4				0x10	// PX4
#define	P_BIT_X5				0x20	// PX5
#define	P_BIT_X6				0x40	// PX6
#define	P_BIT_X7				0x80	// PX7
#define P0_CAHT_TIME_OFF		0x0		// P0 Chata OFF
#define P0_CAHT_TIME_PCLK_256	0x1		// 256/PCLK
#define P0_CAHT_TIME_PCLK_512	0x2		// 512/PCLK
#define P0_CAHT_TIME_PCLK_1024	0x3		// 1024/PCLK
#define P0_CAHT_TIME_PCLK_2048	0x4		// 2048/PCLK
#define P0_CAHT_TIME_PCLK_4096	0x5		// 4096/PCLK
#define P0_CAHT_TIME_PCLK_8192	0x6		// 8192/PCLK
#define P0_CAHT_TIME_PCLK_16384	0x7		// 16384/PCLK
#define	P_PORTNO_P0				0		// P0 PortNo
#define	P_PORTNO_P1				1		// P1 PortNo
#define	P_PORTNO_P2				2		// P2 PortNo
#define	P_PORTNO_P3				3		// P3 PortNo
#define	P_INT_OCCURED			1		// interrupt occured
#define	P_INT_NOT_OCCURED		0		// interrupt not occured

#endif
