 /***********************************************************************
 *                                                                      *
 * main.c                                                               *
 * Zombie shooting game by TK      		                       	*
 * History : 2009/03/17 	start                                   *
 ***********************************************************************/
#include <string.h>
#include "osc.h"
#include "t16.h"
#include "lcd.h"
#include "port.h"
#include "init.h"
#include "lcdManager.h"


/*proto type*/
void t16ch0Int(void)__attribute__ ((interrupt_handler));
void t16ch1Int(void)__attribute__ ((interrupt_handler));
void p0xInt(void)__attribute__ ((interrupt_handler));
void display2lcd(void)__attribute__ ((interrupt_handler)); //**TK**
void Wait(void);
void hardware_init(void);
int main(void);
int random(void); //**TK**
void timer1init(int); //**TK**
void initGame(void); //**TK**
void initStage(void); //**TK**
int executeGame(void); //**TK**
void clearDemo(void); //**TK**
void missedDemo(void); //**TK**
void diedDemo(void); //**TK**
void setNum(unsigned int,unsigned int); //**TK**


/* Global variable define */
 volatile unsigned char t16ch0Flg;
 volatile unsigned char sw2Flg;
 volatile unsigned char sw3Flg;
 volatile unsigned char line_buf[13];		// **TK** line buffer to call displayStr()
 volatile signed int human_y,human_x;		// **TK** point of human machine
 volatile signed int human_shoot_count;		// **TK** work to change human character
 volatile unsigned int random_seed;			// **TK** valuable for semi-random function
 volatile unsigned int game_score;			// **TK** score
 volatile unsigned int best_score;			// **TK** high score
 volatile int game_stage;			// **TK** current stage
 volatile int enemie_left;		// **TK** left enemies to clear this stage
 volatile int game_life;			// **TK** life
 volatile int counter;			// **TK** life

/* enemy struct */
 struct ENEMY {
	 int exist_flag;
	 int enemy_type;
	 int enemy_x;
	 int enemy_y;
	 int option1;
	 int option2;
	 int option3;
	 int option4;
 };

 volatile struct ENEMY enemies[30];

 /* temp screen area */
 volatile unsigned char temp_screen[80*5];


/************************************************************************
 *   main function.
 *   param    :     void
 *   return   :     none
 *   history  :     2009/01/14	start
 ***********************************************************************/
int main(void) {
	int result;
	int end_flag ;
	controlPsc(PSC_PRUN_RUN);        			//prescaler run
	setClockGear(CLG_CCLKGR_1);      			//set clock gear *defalt=0x0

	//IOSC->OSC3
	SET_OSC3_WAIT_CYCLE(OSC3_WAIT_CYCLE_256);
	changeSysClkIoscTo3();


	hardware_init();

	//High Score Clear

	best_score = 0;

	while (1) {

	    initGame();
	    initStage();
		end_flag = 0;

		while (end_flag == 0) {
			startLcdInt();
			result = executeGame();
			stopLcdInt();
			if (result == 1) { // clear
				game_stage ++;
				clearDemo();
				initStage();
			}
			if (result ==2) { // died
				if (game_life >1) {
					game_life = game_life -1;
					missedDemo();
					initStage();
				}else{
				  diedDemo();
				  end_flag = 1;
				}
			}
		}
	}
	return 1;
}

/************************************************************************
*   executeGame function. Initialize screen and valuables
*   param    :     void
*   return   :     int;
*   				1 : clear
*   				2 : miss
*   history  :     2010/03/18   start
***********************************************************************/
int executeGame(void){
	int i,endflag,humanFireFlag;
	int dx,dy;
	int hit_enemy;
	unsigned char human_ch;

	endflag = 0;

	while (endflag ==0) {
		stopLcdInt();
		clearTempScreen((unsigned char *)temp_screen);

		// human move

		if (sw2Flg ==1){   // then upper rocket is on
			human_shoot_count = 6;
			sw2Flg = 0;
		}
		human_ch = 91;
		switch (human_shoot_count) {
			case 6 :
				if (human_y > 4) {
					human_y -= 3 ;
					human_ch = 93;
				}
				human_shoot_count = 5;
				break;
			case 5 :
				if (human_y > 3) {
					human_y -= 2 ;
					human_ch = 92;
				}
				human_shoot_count = 4;
				break;
			case 4 :
				if (human_y > 2) {
					human_y -= 1 ;
					human_ch = 93;
				}
				human_shoot_count = 3;
				break;
			case 3 :
				human_shoot_count = 2;
				break;
			case 2 :
				if (human_y < 28) {
					human_y += 1 ;
				}
				human_shoot_count = 1;
				break;
			case 1 :
				if (human_y < 27) {
					human_y += 2 ;
				}
				human_shoot_count = 0;
				break;
			case 0 :
				if (human_y < 26) {
					human_y += 3 ;
				}
				break;
		}

		putChar((unsigned char *)temp_screen,human_x,human_y,human_ch);


		// human fired

		if (sw3Flg ==1){   // then upper rocket is on
			humanFireFlag = 1;
			sw3Flg = 0;
		}else{
			humanFireFlag = 0;
		}
		hit_enemy = -1;
	    // enemy move & hit check

		for (i=0; i<=29; i++) {
			if (enemies[i].exist_flag != 0) {

				if (enemies[i].enemy_type<90){
					enemies[i].enemy_x += enemies[i].option1;
					if (enemies[i].enemy_x > 72){
						enemies[i].enemy_x = - random()%150;
						enemies[i].enemy_y = random() % 25;

					}
				}

				// human beam hit checking

				if ((humanFireFlag == 1)&&(enemies[i].enemy_type<90)) {
					if (enemies[i].enemy_x > 0){
						dy = human_y - enemies[i].enemy_y;
						if (dy < 0) dy = -dy;
						if (dy < 3) {
							if (hit_enemy < 0){
								hit_enemy = i;
							}else{
								if (enemies[i].enemy_x > enemies[hit_enemy].enemy_x) {
									hit_enemy = i;
								}
							}
						}
					}
				}
				// crash checking

				dx = human_x - enemies[i].enemy_x ;
				if (dx < 0) dx = -dx;
				dy = human_y - enemies[i].enemy_y ;
				if (dy < 0) dy = -dy;

				if ((dx <3)&&(dy<3)&&enemies[i].enemy_type<90) {  // hit by enemy
					if (endflag == 0) endflag= 2;
				}

				switch (enemies[i].enemy_type) {

				case 1:				// define enemy type 1 movement
					if ((random()%2) == 1) {
						enemies[i].enemy_y -=1;
					}else{
						enemies[i].enemy_y +=1;
					}
					if (enemies[i].enemy_y > 30) enemies[i].enemy_y = 30;
					if (enemies[i].enemy_y < 0) enemies[i].enemy_y = 0;
					if (enemies[i].enemy_x > 0) {
						putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,94+(counter % 3));
					}
					break;
				case 2:				// define enemy type 1 movement
					if (enemies[i].option2 == 1) {
						enemies[i].enemy_y -=1;
						if (enemies[i].enemy_y < 0) {
							enemies[i].enemy_y = 0;
							enemies[i].option2 = 0;
						}
					}else{
						enemies[i].enemy_y +=1;
						if (enemies[i].enemy_y > 30) {
							enemies[i].enemy_y = 30;
							enemies[i].option2 = 1;
						}
					}
					if (enemies[i].enemy_x > 0) {
						putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,97+(counter % 3));
					}
					break;

				case 3:				// define enemy type 3 movement
					if ((random()%2) == 1) {
						enemies[i].enemy_y -=3;
					}else{
						enemies[i].enemy_y +=3;
					}

					if (enemies[i].enemy_y > 30) enemies[i].enemy_y = 30;
					if (enemies[i].enemy_y < 0) enemies[i].enemy_y = 0;

					if (enemies[i].enemy_x > 0) {
						putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,100+(counter % 3));
					}
					break;

				case 90:				// explosing
					putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,103);
					enemies[i].enemy_type = 91;
					break;

				case 91:				// explosing
					putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,104);
					enemies[i].enemy_type = 92;
					break;

				case 92:				// explosing
					putChar((unsigned char *)temp_screen,enemies[i].enemy_x,enemies[i].enemy_y,105);
					enemies[i].exist_flag = 0;
					break;
				}
			}
		}
		startLcdInt();
		Wait();
		counter ++;
		if (counter > 100) counter = 0;

		if (hit_enemy >= 0) {
			enemies[hit_enemy].enemy_type = 90;  // exposing
			enemie_left--;
			game_score += game_stage;
			if (enemie_left <= 0) endflag= 1;
		}
	}
	return endflag;
}

/************************************************************************
*   startGame function. Initialize screen and valuables
*   param    :     void
*   return   :     none
*   history  :     2010/03/18   start
***********************************************************************/
void initGame(void) {

	int temp;

	//init display

	sw2Flg = 0;
	//clear LCD
	clearAllLcdLine();
	Wait();

	//fill LCD
	fillAllLcdLine();
	Wait();

	//checker LCD
	displayChecker();
	Wait();

	//checker LCD
	displayChecker2();
	Wait();

	//Init display
	clearAllLcdLine();
	displayStr(0,"S-Fighter");
	displayStr(1,"V1.0");
	displayStr(2,"by T.K");
	displayStr(3,"**push sw2**");
	reverseStr(0);

	//SW2 wait
	random_seed = 0;
	while(sw2Flg == 0)
	{
		temp = random();

	};

	//init valuables

	game_score = 0;
	game_life = 3;
	game_stage = 1;
	timer1init(game_life);
}

/************************************************************************
*   initStage function. Initialize screen and valuables
*   param    :     void
*   return   :     none
*   history  :     2010/03/18   start
***********************************************************************/
void initStage(void) {
	int i,temp;

	//init display

	sw2Flg = 0;

	//checker LCD
	displayChecker();
	Wait();

	//checker LCD
	displayChecker2();
	Wait();

	//Init display
	clearAllLcdLine();
	displayStr(0,"BEAT      ");
	displayStr(1,"  ENEMIES!");
	line_buf[0] ='S';
	line_buf[1] ='C';
	line_buf[2] ='O';
	line_buf[3] ='R';
	line_buf[4] ='E';
	line_buf[5] =':';
	setNum(6,game_score);
	displayStr(2,(char *)line_buf);
	displayStr(3,"**push sw2**");

	//SW2 wait
	while(sw2Flg == 0)
	{
		reverseStr(3);
		Wait();Wait();Wait();
		temp = random();

	};

	//init valuables
	human_y = 16;
	human_x = 66;
	human_shoot_count = 5;
	enemie_left = game_stage * 5 + 10;
	if (enemie_left > 29){
		enemie_left = 29 ;
	}
	for (i=0; i<=29; i++) {
		enemies[i].exist_flag = 0;
	}

	for (i=0;i < enemie_left; i++){
		enemies[i].exist_flag = 1;
		switch (game_stage){
		case 1:
			enemies[i].enemy_type = 1;
			break;
		case 2:
			enemies[i].enemy_type = 2;
			break;
		case 3:
			enemies[i].enemy_type = random()%2 +1;
			break;
		case 4:
			enemies[i].enemy_type = 3;
			break;
		case 5:
			enemies[i].enemy_type = random()%2 +2;
			break;
		default:
			enemies[i].enemy_type = random()%3 +1;
		}

		enemies[i].enemy_x = - random() % 150;
		enemies[i].enemy_y = random() % 25;
		enemies[i].option1 = random() % 4 +1;
		enemies[i].option2 = random() % 2;
	}
	sw2Flg = 0;
	sw3Flg = 0;
	timer1init(game_life);
	counter = 0;
}
/************************************************************************
*   clear demo function.
*   param    :     void
*   return   :     none
*   history  :     2010/03/18   start
***********************************************************************/
void clearDemo(void) {
	int i;

	//checker LCD
	displayChecker();
	Wait();

	//checker LCD
	displayChecker2();
	Wait();

	//Init display
	clearAllLcdLine();
	displayStr(0,"YOU DIT IT! ");
	displayStr(1,"Go to    ");
	displayStr(2,"  next area!");
	displayStr(3,"Be careful!!");
	reverseStr(0);

	for ( i = 0 ; i < 10; i++) {
		reverseStr(0);
		Wait();Wait();Wait();
	}
}
/************************************************************************
*   missed demo function.
*   param    :     void
*   return   :     none
*   history  :     2010/03/18   start
***********************************************************************/
void missedDemo(void) {
	int i;


	for (i=0; i<=20; i++){
		clearTempScreen((unsigned char *)temp_screen);
		putChar((unsigned char *)temp_screen,human_x+random()%5-2,human_y+random()%5,103+random()%3);
		displayTempScreen((char *)temp_screen);
		Wait();
	}

	//checker LCD
	displayChecker();
	Wait();

	//checker LCD
	displayChecker2();
	Wait();

	//Init display
	clearAllLcdLine();
	displayStr(0,"You missed..");
	displayStr(1,"Be          ");
	displayStr(2,"  more      ");
	displayStr(3,"   careful!!");

	for ( i = 0 ; i < 10; i++) {
		reverseStr(0);
		Wait();Wait();Wait();
	}
}
/************************************************************************
*   died demo function.
*   param    :     void
*   return   :     none
*   history  :     2010/03/18   start
***********************************************************************/
void diedDemo(void) {
	int i;

	for (i=0; i<=20; i++){
		clearTempScreen((unsigned char *)temp_screen);
		putChar((unsigned char *)temp_screen,human_x+random()%5-2,human_y+random()%5,103+random()%3);
		displayTempScreen((char *)temp_screen);
		Wait();
	}

	//checker LCD
	displayChecker();
	Wait();

	//checker LCD
	displayChecker2();
	Wait();

	//Init display
	clearAllLcdLine();
	displayStr(0,"GAME OVER");
	line_buf[0] ='S';
	line_buf[1] ='C';
	line_buf[2] ='O';
	line_buf[3] ='R';
	line_buf[4] ='E';
	line_buf[5] =':';
	setNum(6,game_score);
	displayStr(1,(char *)line_buf);
	if (game_score > best_score) {
	  displayStr(2,"You got");
	  displayStr(3," best score!");
	  best_score = game_score;
	}else{
		line_buf[0] ='B';
		line_buf[1] ='E';
		line_buf[2] ='S';
		line_buf[3] ='T';
		line_buf[4] =' ';
		line_buf[5] =':';
		setNum(6,best_score);
		displayStr(2,(char *)line_buf);
	}
	for ( i = 0 ; i < 15; i++) {
		reverseStr(0);
		Wait();Wait();Wait();
	}
}
 /************************************************************************
 *   t16ch1Int function.
 * 	 t16Ch1 interrupt routine.
 *   param    :     void
 *   return   :     none
 *   history  :     2009/01/14   start
 ***********************************************************************/
void t16ch1Int(void) {

	resetT16Ch1IF();
	P2_OUT ^= 0x80;			//LED ON/OFF

}

/************************************************************************
 *   t16ch0Int function.
 * 	 t16Ch0 interrupt routine.
 *   param    :     void
 *   return   :     none
 *   history  :     2009/01/14   start
 ***********************************************************************/
void t16ch0Int(void) {
	resetT16Ch0IF();
	t16ch0Flg = 1;
 }
 /************************************************************************
 *	 p0xInt function.
 *   P0X interrupt routine.
 *   param    :     void
 *   return   :     int
 *   history  :     2009/01/14	start
 ***********************************************************************/
 void p0xInt(void) {
	/* interrupt flag*/
	char intFlag = 0;
	//Check Interrupt status
	if(isP06Int() == P_INT_OCCURED) {
		//P06 intterupt occured
		intFlag |= P_BIT_X6;
		sw2Flg = 1;
	}
	if(isP07Int() == P_INT_OCCURED) {
		//P07 intterupt occured
		intFlag |= P_BIT_X7;
		sw3Flg = 1;
	}
	//Interrupt Flag clear
	resetP0IF((unsigned char) intFlag);
 }

 /************************************************************************
  *   Transfer virtual screen data to LCD display at LCD interrupt
  *   param    :     void
  *   return   :     none
  *   history  :     2010/03/17	start
  ***********************************************************************/
 void display2lcd(void){		//**TK**
	 displayTempScreen((char *)temp_screen);			//**TK**
 	resetLcdIF();				//**TK**
 }


 /************************************************************************
  *   Generating semi-random number
  *   param    :     void
  *   return   :     0-255 random number
  *   history  :     2010/03/17	start
  ***********************************************************************/
 int random(void){								//**TK**
 	random_seed = (random_seed * 113 + 7);		//**TK**
 	return (random_seed % 0x100);				//**TK**
 }

 /************************************************************************
   *   Display
   *   param    :     num : unsigned int value to be displayed
   *   				  loc : column location in line_buffer
   *   return   :     none
   *   history  :     2010/03/17	start
   ***********************************************************************/
  void setNum(unsigned int loc,unsigned int num){	//**TK**
	unsigned int i,cmp;							//**TK**
  	i = 0 ;										//**TK**
  	cmp = 10000;
  	for (i = 0; i < 5; i++) {
  		line_buf[loc+i] = num / cmp + 0x30;
  		num = num % cmp;
  		cmp /= 10;
  	}
  	line_buf[loc+i] ='\0';
  }

 /************************************************************************
 *   Wait function.
 *   wait.
 *   param    :     void
 *   return   :     none
 *   history  :     2009/01/14	start
 ***********************************************************************/
void Wait(void) {

	t16ch0Flg = 0;
	//start T16CH0 timer
	startT16Ch0();

	//T16CH0 timer interrupt enable
	startT16Ch0Int();

	while(t16ch0Flg != 1){
	    asm("halt");
		asm("nop");
    }
}
/************************************************************************
 *   hardware init function.
 *   software wait.
 *   param    :     void
 *   return   :     none
 *   history  :     2009/01/14	start
 ***********************************************************************/
void hardware_init(void) {

	InitParamT16 initParam;

	/*---------------------------------------------*/
	//P06,P07 = INPUT
	setPortInput(0xC0, 0x00, 0x00, 0x00);
	//P27 = OUTPUT
	setPortOutput(0x00, 0x00, 0x80, 0x00);
	contorlP0IputOn(0xC0);
	initP0Int(0x03);
 	setP0IntEdgeDown(0xC0);
	setP0Chat4to7(P0_CAHT_TIME_PCLK_8192);
	startP0Int(0xC0);

	/*---------------------------------------------*/
	//T16 CH0 setting(wait 0.25s setting)
    initParam.clkMode = T16_CLK_MODE_IN;		//internal
	initParam.cntMode = T16_CNT_MODE_ONESHOT;	//oneshot
	initParam.cntClock = T16_IN_CLOCK_8192;     //1/8192
	initParam.exActiveLv = T16_EX_ACTIVE_LV_UP;	//Polar 1:Rise
	//initParam.count = 0x003cf * 2;	                //reload data 975
	initParam.count = 0x0080;	                //**TK**

    initT16Ch0(&initParam);
	initT16Ch0Int(0x03);

	/*---------------------------------------------*/
	//T16 CH1 setting(moved by TK)
	timer1init(3);

	/*---------------------------------------------*/
	// initializes LCD
	initLcdPower(LCD_PWR_BOOSTER_OFF, LCD_HEAVY_PROTECT_OFF);
	startLcdClk(LCD_CLK_SELECT_HSCLK, LCD_CLK_DIV_32);
	initLcd(LCD_DUTY_32, LCD_CONTRAST_LV_10);
	reverseLcdCom();
	reverseLcdSeg();
	initLcdInt(0x03);		//**TK**
	lcdOn();
}

void timer1init(int timer_value) {

	InitParamT16 initParam;

	stopT16Ch1();
	stopT16Ch1Int();
    initParam.clkMode = T16_CLK_MODE_IN;		//internal
	initParam.cntMode = T16_CNT_MODE_REPEAT;	//repeat
	initParam.cntClock = T16_IN_CLOCK_8192;     //1/8192
	initParam.exActiveLv = T16_EX_ACTIVE_LV_UP;	//Polar 1:Rise
	//initParam.count = 0x01e7 ;	                //reload data 487
	initParam.count = 0x01e7 /3 * timer_value ;	                //**TK**
    initT16Ch1(&initParam);
	initT16Ch1Int(0x03);
	startT16Ch1();
	startT16Ch1Int();
}

